module hex_cone(d, h, a) {
	intersection() {
		hex(d, h);
		cylinder(r1=2*h/tan(a), r2=0, h=h, center=true);
	}
}

module hex(d, h) {
	cylinder(r=d/sqrt(3), h=h, $fn=6, center=true);
}

module m_cap(m, head_d, sock_d, sock_l, thread_l) {
	thread_d = m;
	head_l = m;
	difference() {
		union() {
			translate([0,0,-head_l/2]) cylinder(r=head_d/2, h=head_l, center=true);
			translate([0,0,0.5+thread_l/2]) cylinder(r=thread_d/2, h=thread_l+1, center=true);
		}
		translate([0,0,sock_l/2-head_l]) hex(sock_d, sock_l+0.01);
	}
}

module m_nut(m, d, l) {
	difference() {
		hex(d, l);
		cylinder(r=m/2, h=l+1, center=true);
	}
}

module m3_cap(l) { m_cap(3, 5.5, 2.5, 1.3, l); }
module m4_cap(l) { m_cap(4, 7, 3, 2.0, l); }
module m5_cap(l) { m_cap(5, 8, 4, 2.7, l); }
module m6_cap(l) { m_cap(6, 10, 5, 3.3, l); }
module m8_cap(l) { m_cap(8, 13, 6, 4.3, l); }

module m3_nut() { m_nut(3, 5.5, 2.4); }
module m4_nut() { m_nut(4, 7, 3.2); }
module m5_nut() { m_nut(5, 8, 4.7); }
module m6_nut() { m_nut(6, 10, 5.2); }
module m8_nut() { m_nut(8, 13, 6.8); }

module m3_nyloc() { m_nut(3, 5.5, 4); }
module m4_nyloc() { m_nut(4, 7.0, 5); }
module m5_nyloc() { m_nut(5, 8, 5); }
module m6_nyloc() { m_nut(6, 10, 6); }
module m8_nyloc() { m_nut(8, 13, 8); }
